      PROGRAM WWRUN
      IMPLICIT REAL*8(A-H,O-Z)
C
      WRITE(*,*) '  *** WALD-WOLFOWITZ TWO-SAMPLE RUNS TEST ***'
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      WRITE(*,*) 'ENTER NUMBER OF RUNS R AND SAMPLE SIZES M AND N:'
      READ(*,*) IR,M,N
      P = ZERO
      L = MIN0(M,N)
      IF(IR.LT.2) GO TO 20
      IF(M.EQ.N.AND.IR.GT.2*L-1) THEN
         P = ONE
         GO TO 20
      END IF
      IF(IR.GT.2*L) THEN
         P = ONE
         GO TO 20
      END IF
      IZ = IR/2
      DO 10 I = 1,IZ
         W = COMB(M-1,I-1)*COMB(N-1,I-1)
         IF(2*I.LE.IR) P = P+TWO*W
         IF(2*I+1.LE.IR) P = P+(ONE*(M+N)/I-TWO)*W
   10 CONTINUE
      P = P/COMB(M+N,M)
   20 WRITE(*,30) 'EXACT WALD-WOLFOWITZ RUNS TEST P-VALUE = ',P
   30 FORMAT(T6,A,G16.8)
      END
C
C
      FUNCTION COMB(N,M)
      IMPLICIT REAL*8(A-H,O-Z)
C
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      R = DLOG(PI*2)/2
      Z = ONE+N
      D = Z
      F = Z+10
      DO 10 I = 1,9
         D = D*(Z+I)
   10 CONTINUE
      U1 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+M
      D = Z
      F = Z+10
      DO 20 I = 1,9
         D = D*(Z+I)
   20 CONTINUE
      U2 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+N-M
      D = Z
      F = Z+10
      DO 30 I = 1,9
         D = D*(Z+I)
   30 CONTINUE
      U3 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1180)
      COMB = DEXP(U1-U2-U3)
      RETURN
      END
