      PROGRAM AGREEPV
      IMPLICIT REAL*8(A-H,O-Z)
C
C         PROGRAM MODIFIED 12/12/2005
C
      DIMENSION  X(200),Y(200)
      CHARACTER  FIN*40,FOUT*40
C
      ZERO = 0.0D0
      WRITE(*,1000) '*** PROGRAM AGREEPV ***'
 1000 FORMAT(T19,A)
      WRITE(*,1100) 'PROGRAM AGREEPV COMPUTES RHO, CORRELATION, AND ',
     +              'THE P-VALUE FOR AGREEMENT ','BETWEEN X AND Y ',
     +              'VALUES FOR AN EXISTING DATA SET. THE PRESENT ',
     +              'MAXIMUM IS M = 200 PAIRED X AND Y VALUES. ',
     +              'RESULTS OF THIS PROGRAM ARE IN NAMED OUTPUT FILE.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,/,T2,A,/,T2,A,/)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF THE X AND Y VALUES:'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1200) FOUT
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
C
      READ(4,*) M
      READ(4,*) (X(I),Y(I),I=1,M)
      CLOSE(4)
      DELTA = ZERO
      DO 1600 J = 1,M
         DELTA = DELTA+DABS(X(J)-Y(J))
 1600 CONTINUE
      DELTA = DELTA/M
      CALL MRBP(M,X,Y,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      WRITE(7,2200) 'OBSERVED VALUE OF DELTA = ',DELTA
 2200 FORMAT(T5,A,G15.8)
      WRITE(7,2200) 'EXPECTED VALUE OF DELTA = ',EDEL
      WRITE(7,2200) 'VARIANCE OF DELTA = ',VAR
      WRITE(7,2200) 'SKEWNESS OF DELTA = ',GAM
      WRITE(7,2200) 'STANDARDIZED VALUE OF DELTA = ',T
      WRITE(7,2200) 'MEASURE OF AGREEMENT BETWEEN X AND Y = ',RHO
      WRITE(7,2200) 'AGREEMENT P-VALUE BETWEEN X AND Y = ',PROB
 2300 FORMAT(T5,A,G15.8,/)
      CO = ZERO
      COO = ZERO
      CP = ZERO
      CPP = ZERO
      COP = ZERO
      DO 2400 I = 1,M
          CO = CO+X(I)
          COO = COO+X(I)**2
          CP = CP+Y(I)
          CPP = CPP+Y(I)**2
          COP = COP+X(I)*Y(I)
 2400 CONTINUE
      R = (COP*M-CO*CP)/DSQRT((COO*M-CO*CO)*(CPP*M-CP*CP))
      RR =  R*R
      WRITE(7,2200) 'PEARSON CORRELATION COEFFICIENT = ',R
      WRITE(7,2300) 'SQUARED CORRELATION COEFFICIENT = ',RR
      STOP 'AGREEPV RESULTS IN NAMED OUTPUT FILE'
      END
C
C
      SUBROUTINE MRBP(KG,X,Y,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  DATA(200,2),X(200),Y(200)
C
      V = 1.0D0
      DO 20 I = 1,KG
         DATA(I,1) = X(I)
         DATA(I,2) = Y(I)
   20 CONTINUE
      CALL CALC(V,KG,DATA,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      RETURN
      END
C
C
      SUBROUTINE CALC(V,KG,DATA,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  D(400,400),SJ(200,2,2),SJ2(200,2,2),SJ3(200,2,2),
     1   UJ(200,2,2),DATA(200,2),SIJ(2,2),SIJ2(2,2),SIJ3(2,2),
     2   UIJ(2,2),TIJ2(2,2),TIJ3(2,2),VI(2,2)
C
      ONE=1.0D0
      ZERO=0.0D0
      K2G=KG*2
      DO 4 I=1,K2G
         DO 3 J=1,K2G
            D(I,J)=ZERO
    3    CONTINUE
    4 CONTINUE
      DO 10 I=1,KG
         DO 9 J=1,2
            DO 8 K=I,KG
               LO=1
               IF(I.EQ.K) LO=J
               DO 7 L=LO,2
                  IJ=2*(I-1)+J
                  KL=2*(K-1)+L
                  D(IJ,KL)=D(IJ,KL)+(DATA(I,J)-DATA(K,L))**2
                  D(IJ,KL)=D(IJ,KL)**(V/2)
                  D(KL,IJ)=D(IJ,KL)
    7          CONTINUE
    8       CONTINUE
    9    CONTINUE
   10 CONTINUE
      DO 30 IS=1,2
         DO 29 IR=1,2
            IF(IR.EQ.IS) GO TO 29
            SIJ(IR,IS)=ZERO
            SIJ2(IR,IS)=ZERO
            SIJ3(IR,IS)=ZERO
            DO 28 I=1,KG
               SJ(I,IR,IS)=ZERO
               SJ2(I,IR,IS)=ZERO
               SJ3(I,IR,IS)=ZERO
               DO 27 J=1,KG
                  IRR=(I-1)*2+IR
                  JSS=(J-1)*2+IS
                  SJ(I,IR,IS)=SJ(I,IR,IS)+D(IRR,JSS)
                  SJ2(I,IR,IS)=SJ2(I,IR,IS)+D(IRR,JSS)**2
                  SJ3(I,IR,IS)=SJ3(I,IR,IS)+D(IRR,JSS)**3
   27          CONTINUE
               SIJ(IR,IS)=SIJ(IR,IS)+SJ(I,IR,IS)
               SIJ2(IR,IS)=SIJ2(IR,IS)+SJ2(I,IR,IS)
               SIJ3(IR,IS)=SIJ3(IR,IS)+SJ3(I,IR,IS)
   28       CONTINUE
   29    CONTINUE
   30 CONTINUE
      TIJ2(1,2)=ZERO
      TIJ3(1,2)=ZERO
      VI(1,2)=ZERO
      UIJ(1,2)=ZERO
      DO 100 I=1,KG
         TIJ2(1,2)=TIJ2(1,2)+SJ(I,1,2)**2+
     1     SJ(I,2,1)**2
         TIJ3(1,2)=TIJ3(1,2)+SJ(I,1,2)**3+
     1     SJ(I,2,1)**3
         VI(1,2)=VI(1,2)+SJ(I,1,2)*SJ2(I,1,2)+
     1     SJ(I,2,1)*SJ2(I,2,1)
         UJ(I,1,2)=ZERO
         DO 90 J=1,KG
            IRR=2*(I-1)+1
            JSS=2*(J-1)+2
            UJ(I,1,2)=UJ(I,1,2)+
     1        D(IRR,JSS)*SJ(I,1,2)*SJ(J,2,1)
   90    CONTINUE
         UIJ(1,2)=UIJ(1,2)+UJ(I,1,2)
  100 CONTINUE
      T1=ZERO
      EDEL=ZERO
      VAR=ZERO
      IF(KG.LE.2) GO TO 150
      T1=T1+(SIJ(1,2)**3)*4-SIJ(1,2)*TIJ2(1,2)*KG*6+
     1  UIJ(1,2)*KG*KG*6+TIJ3(1,2)*KG*KG*2+
     2  SIJ(1,2)*SIJ2(1,2)*KG*KG*3-
     3  VI(1,2)*KG*KG*KG*3+SIJ3(1,2)*KG*KG*KG*KG
  150 EDEL=EDEL+SIJ(1,2)
      VAR=VAR+SIJ(1,2)*SIJ(1,2)-TIJ2(1,2)*KG+SIJ2(1,2)*KG*KG
      IF(KG.LE.2) GO TO 200
      T1=T1/(KG-2)
  200 C1=ONE/KG/KG
      EDEL=C1*EDEL
      VAR=VAR*C1*C1/(KG-1)
      GAM=C1*C1*C1*T1/(KG-1)
      GAM=GAM/DSQRT(VAR**3)
      T=(DELTA-EDEL)/DSQRT(VAR)
      RHO=ONE-(DELTA/EDEL)
      CALL PVALUE(T,GAM,PROB)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ONE,ZERO,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
