      PROGRAM LAD
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*80,FIN*40,FOUT*40,RES*40
C
      WRITE(*,1000) '*** PROGRAM LAD ***'
 1000 FORMAT(5(/),T19,A)
      WRITE(*,1100) 'PROGRAM LAD COMPUTES A LEAST ABSOLUTE ',
     +              'DEVIATION REGRESSION ANALYSIS','OF AN ',
     +              'EXISTING DATA SET, USING THE ACM ALGORITHM ',
     +              'NUMBER 478.','PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 600 OBSERVATIONS,',
     +              'N = 20 INDEPENDENT VARIABLES.',
     +              'RESULTS OF PROGRAM LAD ARE IN NAMED OUTPUT FILE.',
     +              'NOTE THAT THE DEPENDENT VARIABLE (Y) MUST BE ',
     +              'THE LAST VARIABLE','(THAT IS THE RIGHT-MOST ',
     +              'VARIABLE) IN THE DATA SET.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,A,/,T2,A,/,T10,A,/,
     +   T10,A,/,T2,A,/,T2,A,A,/,T2,A,A,/)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,1200) FOUT
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESIDUAL DATA'
      READ(*,1200) RES
      WRITE(*,*) 'ENTER OUTPUT HEADING:'
      READ(*,1200) HEAD
      TOLER = 1.0D-9
      WRITE(*,1300) 'TOLERANCE = ', TOLER
 1300 FORMAT(T10,A,E10.4)
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
      CALL LEAST(TOLER,HEAD,RES)
      STOP 'LAD RESULTS IN NAMED OUTPUT FILE'
      END
C
C
      SUBROUTINE LEAST(TOLER,HEAD,RES)
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*80,RES*40
      DIMENSION  A(602,22),X(20),E(600),B(600),Y(600),YH(600),LS(600)
C
      READ(4,*) M,N
      READ(4,*) ((A(I,J),J = 1,N+1),I = 1,M)
      CLOSE(4)
      DO 1000 I = 1,M
         B(I) = A(I,N+1)
         Y(I) = B(I)
 1000 CONTINUE
      WRITE(7,1100)
 1100 FORMAT(T25,'*** OUTPUT OF LAD ANALYSIS ***',2(/))
      WRITE(7,1200) HEAD
 1200 FORMAT(T5,'HEADING:  ',A,/)
C
      CALL L1(M,N,A,B,TOLER,X,E,LS)
C
      DO 1700 I = 1,N
         WRITE(7,1600) 'LAD REGRESSION COEFFICIENT',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      IRANK = A(M+1,N+2)
      ITER = A(M+2,N+2)
      IEXCODE = A(M+2,N+1)
      SUMRE = A(M+1,N+1)
      WRITE(7,1800) IRANK,ITER,IEXCODE
 1800 FORMAT(/,T5,'MATRIX RANK = ',I3,/,T5,'ITERATIONS =  ',I3,/,T5,
     +   'EXIT CODE =   ',I3)
      WRITE(7,1900) 'NOTE: EXIT CODE 0 INDICATES A NON-UNIQUE ',
     +   'SOLUTION.','NOTE: EXIT CODE 1 INDICATES A SUCCESSFUL ',
     +   'SOLUTION.','NOTE: EXIT CODE 2 INDICATES ROUNDING ERRORS.'
 1900 FORMAT(/,T5,A,A,/,T5,A,A,/,T5,A)
      WRITE(7,2000) M,N,SUMRE
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I3,/,T5,'INDEPENDENT',
     +   ' VARIABLES = ',I2,/,T5,'SUM OF ABSOLUTE VALUES OF THE',
     +   ' RESIDUALS = ', G15.8,//)
C
      WRITE(7,2200) 'CASE','Y-VALUES','Y-HAT VALUES','RESIDUALS'
 2200 FORMAT(T5,A,T20,A,T40,A,T63,A,/)
      DO 2400 I = 1,M
         YH(I) = Y(I)-E(I)
         WRITE(7,2300) I,Y(I),YH(I),E(I)
 2300    FORMAT(T5,I3,3(8X,E14.7))
 2400 CONTINUE
C
      OPEN(8,FILE=RES,STATUS='NEW')
      DO 2500 I = 1,M
         WRITE(8,*) E(I)
 2500 CONTINUE
      CLOSE(8)
C
      WRITE(7,2600)
 2600 FORMAT(2(/),T26,'*** END OF LAD ANALYSIS ***')
      RETURN
      END
C
C
      SUBROUTINE L1(M,N,A,B,TOLER,X,E,LS)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(602,22),X(20),E(600),B(600),LS(600)
      LOGICAL  STAGE,TEST
      DATA  BIG/1.0D200/
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      M1 = M+1
      N1 = N+1
      M2 = M+2
      N2 = N+2
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10   CONTINUE
      DO 40 I = 1,M
         A(I,N2) = N+I
         A(I,N1) = B(I)
         IF(B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20      CONTINUE
 30      E(I) = ZERO
 40   CONTINUE
C
      DO 60 J = 1,N1
         SUM = ZERO
         DO 50 I = 1,M
            SUM = SUM+A(I,J)
 50      CONTINUE
         A(M1,J) = SUM
 60   CONTINUE
C
      STAGE = .TRUE.
      KOUNT = 0
      KR = 1
      KL = 1
 70   AMAX = -ONE
      DO 80 J = KR,N
         IF(DABS(A(M2,J)).GT.N) GO TO 80
         D = DABS(A(M1,J))
         IF(D.LE.AMAX) GO TO 80
         AMAX = D
         IN = J
 80   CONTINUE
      IF(A(M1,IN).GE.ZERO) GO TO 100
      DO 90 I = 1,M2
         A(I,IN) = -A(I,IN)
 90   CONTINUE
C
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF(D.LE.TOLER) GO TO 110
         K = K+1
         B(K) = A(I,N1)/D
         LS(K) = I
         TEST = .TRUE.
 110  CONTINUE
 120  IF(K.GT.0) GO TO 130
      TEST = .FALSE.
      GO TO 150
 130  AMIN = BIG
      DO 140 I = 1,K
         IF(B(I).GE.AMIN) GO TO 140
         J = I
         AMIN = B(I)
         IOUT = LS(I)
 140  CONTINUE
      B(J) = B(K)
      LS(J) = LS(K)
      K = K-1
C
 150  IF(TEST.OR..NOT.STAGE) GO TO 170
      DO 160 I = 1,M2
         D = A(I,KR)
         A(I,KR) = A(I,IN)
         A(I,IN) = D
 160  CONTINUE
      KR = KR+1
      GO TO 260
 170  IF(TEST) GO TO 180
      A(M2,N1) = TWO
      GO TO 350
 180  PIVOT = A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
      DO 190 J = KR,N1
         D = A(IOUT,J)
         A(M1,J) = A(M1,J)-D-D
         A(IOUT,J) = -D
 190  CONTINUE
      A(IOUT,N2) = -A(IOUT,N2)
      GO TO 120
C
 200  DO 210 J = KR,N1
         IF(J.EQ.IN) GO TO 210
         A(IOUT,J) = A(IOUT,J)/PIVOT
 210  CONTINUE
      DO 220 J = KR,N1
         IF(J.EQ.IN) GO TO 220
         CALL COL(A(1,J),A(1,IN),A(IOUT,J),M1,IOUT)
 220  CONTINUE
      DO 240 I = 1,M1
         IF(I.EQ.IOUT) GO TO 240
         A(I,IN) = -A(I,IN)/PIVOT
 240  CONTINUE
      A(IOUT,IN) = ONE/PIVOT
      D = A(IOUT,N2)
      A(IOUT,N2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT+1
      IF(.NOT.STAGE) GO TO 270
C
      KL = KL+1
      DO 250 J = KR,N2
         D = A(IOUT,J)
         A(IOUT,J) = A(KOUNT,J)
         A(KOUNT,J) = D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1) GO TO 70
C
      STAGE = .FALSE.
C
 270  AMAX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF(D.GE.ZERO) GO TO 280
         IF(D.GT.-TWO) GO TO 290
         D = -D-TWO
 280  IF(D.LE.AMAX) GO TO 290
      AMAX = D
      IN = J
 290  CONTINUE
      IF(AMAX.LE.TOLER) GO TO 310
      IF(A(M1,IN).GT.ZERO) GO TO 100
      DO 300 I = 1,M2
         A(I,IN) = -A(I,IN)
 300  CONTINUE
      A(M1,IN) = A(M1,IN)-TWO
      GO TO 100
C
 310  L = KL-1
      DO 330 I = 1,L
         IF(A(I,N1).GE.ZERO) GO TO 330
         DO 320 J = KR,N2
            A(I,J) = -A(I,J)
 320     CONTINUE
 330  CONTINUE
      A(M2,N1) = ZERO
      IF(KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = DABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER) GO TO 350
 340  CONTINUE
      A(M2,N1) = ONE
 350  DO 380 I = 1,M
         K = A(I,N2)
         D = A(I,N1)
         IF(K.GT.0) GO TO 360
         K = -K
         D = -D
 360  IF(I.GE.KL) GO TO 370
      X(K) = D
      GO TO 380
 370  K = K-N
      E(K) = D
 380  CONTINUE
      A(M2,N2) = KOUNT
      A(M1,N2) = N1-KR
      SUM = ZERO
      DO 390 I = KL,M
         SUM = SUM+A(I,N1)
 390  CONTINUE
      A(M1,N1) = SUM
      RETURN
      END
C
C
      SUBROUTINE COL(V1,V2,AMLT,M1,IOUT)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  V1(M1),V2(M1)
C
      DO 10 I = 1,M1
         IF(I.EQ.IOUT) GO TO 10
         V1(I) = V1(I)-V2(I)*AMLT
  10  CONTINUE
      RETURN
      END
