      PROGRAM EGSECT
      IMPLICIT REAL*8(A-H,O-Z)
C
C               EXACT G-SAMPLE EMPIRICAL COVERAGE TEST FOR V > 0
C            M(1),...,M(G) ARE G SAMPLE SIZES AND N = M(1)+...+M(G)
C  DATA IS ASSUMED TO CONSIST OF CONTINUOUS UNIVARIATE OBSERVATIONS (NO TIES).
C
      CHARACTER FIN*40,FOUT*40
      DIMENSION M(11),R(50),Y(50),C(21,11),X(20,11)
C
C  IF G > 10, N > 50 OR AN M(I) > 20, REVISE THE ABOVE DIMENSION STATEMENT.
C
      ONE = 1.0D0
      ZERO = 0.0D0
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,'(A)') FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,'(A)') FOUT
      WRITE(*,*) 'ENTER V, G, M(1),...,M(G)'
      READ(*,*) V,NG,(M(I),I=1,NG)
      M(NG+1) = 0
      IF(NG.LT.2) THEN
        WRITE(*,*) 'PROGRAM TERMINATED SINCE G IS LESS THAN 2'
        GO TO 300
      ENDIF
      N = 0
      DO 10 I = 1,NG
        N = N+M(I)
   10 CONTINUE
      OPEN(5,FILE=FIN)
      READ(5,*) (Y(I),I = 1,N)
      CLOSE(5)
      A1 = ZERO
      A2 = ZERO
      A3 = ONE*N-0.1D0
      B1 = -1.0D30
      B2 = 1.0D30
   13 IF(A2.GT.A3) GO TO 17
      DO 14 I = 1,N
        IF(Y(I).GT.B1.AND.Y(I).LT.B2) B2 = Y(I)+1.0D-8
   14 CONTINUE
      DO 15 I = 1,N
        W = DABS(Y(I)-B2)
        IF(W.LT.1.0D-7) A1 = A1+1
   15 CONTINUE
      A4 = A2+(A1+1)/2
      DO 16 I = 1,N
        W = DABS(Y(I)-B2)
        IF(W.LT.1.0D-7) R(I) = A4
   16 CONTINUE
      A2 = A2+A1
      A1 = ZERO
      B1 = B2
      B2 = 1.0D30
      GO TO 13
   17 K = 0
      DO 19 I = 1,NG
        DO 18 J = 1,M(I)
          K = K+1
          X(J,I) = R(K)
   18   CONTINUE
   19 CONTINUE
      DO 30 I = 1,NG
        J = M(I)
        K = J/2+1
   21   K = K-1
        W = X(K,I)
        GO TO 23
   22   W = X(J,I)
        X(J,I) = X(1,I)
        J = J-1
   23   II = K
   24   L = 2*II
        IF(L-J) 25,26,27
   25   IF(X(L+1,I).GE.X(L,I)) L = L+1
   26   IF(W.GE.X(L,I)) GO TO 27
        X(II,I) = X(L,I)
        II = L
        GO TO 24
   27   X(II,I) = W
        IF(K.GT.1) GO TO 21
        IF(J.GE.2) GO TO 22
   30 CONTINUE
      DO 40 I = 1,NG
        DO 39 J = 1,M(I)+1
          IF(J.EQ.1) THEN
            C(J,I) = X(J,I)/(N+1)
          ELSEIF(J.EQ.M(I)+1) THEN
            C(J,I) = ONE-X(J-1,I)/(N+1)
          ELSE
            C(J,I) = (X(J,I)-X(J-1,I))/(N+1)
          ENDIF
   39   CONTINUE
   40 CONTINUE
      T1 = ZERO
      DO 100 I = 1,NG
        DO 90 J = 1,M(I)+1
          T1 = T1+DABS(C(J,I)-ONE/(M(I)+1))**V
   90   CONTINUE
  100 CONTINUE
      T1 = T1*(ONE-1.0D-12)
      CALL PERM(N,NG,M,KOUNT1,KOUNT2,T1,V)
      PVAL = ONE*KOUNT2/KOUNT1
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,150) 'EXACT G-SAMPLE EMPIRICAL COVERAGE TEST RESULTS'
  150 FORMAT(/,T18,A,/)
      WRITE(6,160) 'INPUT HAS ',N,' OBSERVATIONS'
  160 FORMAT(T3,A,I5,A)
      WRITE(6,170) 'THE COVERAGE EXPONENT = ',V
  170 FORMAT(T3,A,G16.8)
      WRITE(6,180) 'THERE ARE ',NG,' GROUPS OF SIZES',(M(I),I = 1,NG)
  180 FORMAT(T3,A,I3,A,10I4)
      WRITE(6,190) 'OBSERVED GSECT STATISTIC = ',T1
  190 FORMAT(T6,A,G16.8)
      WRITE(6,200) 'THE TOTAL NUMBER OF VALUES = ',KOUNT1
  200 FORMAT(T6,A,I12)
      WRITE(6,200) 'NUMBER OF VALUES  OBSERVED VALUE = ',KOUNT2
      WRITE(6,190) 'EXACT P-VALUE OF OBSERVED GSECT STATISTIC = ',PVAL
  300 END
C
C
      SUBROUTINE PERM(N,G,B,KOUNT1,KOUNT2,T1,V)
C
      DOUBLE PRECISION  T1,V
      INTEGER  G,B(11),P(50),A(11,50)
C
      K = G
      IF(B(G+1).NE.0) K = K+1
      L = N
      DO 50 I = 1,K-1
         DO 30 J = 1,B(I)
            A(I,J) = I
   30    CONTINUE
         DO 40 J = B(I)+1,L
            A(I,J) = I+1
   40    CONTINUE
         L = L-B(I)
   50 CONTINUE
      KOUNT1 = 0
      KOUNT2 = 0
   60 I = K-1
      NMARKS = B(K)+B(I)
      IF(KOUNT1.EQ.0) GO TO 130
   70 DO 80 J = 1,NMARKS-1
         IF(A(I,J).EQ.I.AND.A(I,J+1).EQ.I+1) THEN
            LIMIT = J-2
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)-1
            IF(LIMIT.LE.0) GO TO 130
            GO TO 110
         END IF
   80 CONTINUE
      IF(NMARKS.EQ.1) GO TO 100
      DO 90 J = 1,NMARKS/2
         ITEMP = A(I,J)
         A(I,J) = A(I,NMARKS-J+1)
         A(I,NMARKS-J+1) = ITEMP
   90 CONTINUE
  100 I = I-1
      IF(I.EQ.0) RETURN
      NMARKS = NMARKS+B(I)
      GO TO 70
  110 IFLAG = 0
      DO 120 J = 1,LIMIT
         IF(A(I,J).EQ.I+1.AND.A(I,J+1).EQ.I) THEN
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)+1
            IFLAG = 1
         END IF
  120 CONTINUE
      IF(IFLAG.EQ.1) GO TO 110
  130 DO 140 J = 1,N
         A(K,J) = A(1,J)
  140 CONTINUE
      IF(K.EQ.2) GO TO 170
      DO 160 L = 2,K-1
         M = 1
         DO 150 J = 1,N
            IF(A(K,J).EQ.L) THEN
               A(K,J) = A(L,M)
               M = M+1
            END IF
  150    CONTINUE
  160 CONTINUE
  170 LL = 1
      DO 190 II = 1,K
         DO 180 JJ = 1,N
            IF(A(K,JJ).EQ.II) THEN
               P(LL) = JJ
               LL = LL+1
            END IF
  180    CONTINUE
  190 CONTINUE
      CALL DVAL(N,G,B,P,KOUNT2,T1,V)
      KOUNT1 = KOUNT1+1
      GO TO 60
      END
C
C
      SUBROUTINE DVAL(N,NG,M,P,KOUNT2,T1,V)
C
      DOUBLE PRECISION  ZERO,ONE,T,T1,V,C(21,11),X(20,11)
      INTEGER  M(11),P(50)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      N1 = 0
      DO 105 I = 1,NG
        DO 104 J = 1,M(I)
          N1 = N1+1
          X(J,I) = P(N1)
  104   CONTINUE
  105 CONTINUE
  110 DO 120 I = 1,NG
        J = M(I)
        K = J/2+1
  111   K = K-1
        W = X(K,I)
        GO TO 113
  112   W = X(J,I)
        X(J,I) = X(1,I)
        J = J-1
  113   II = K
  114   L = 2*II
        IF(L-J) 115,116,117
  115   IF(X(L+1,I).GE.X(L,I)) L = L+1
  116   IF(W.GE.X(L,I)) GO TO 117
        X(II,I) = X(L,I)
        II = L
        GO TO 114
  117   X(II,I) = W
        IF(K.GT.1) GO TO 111
        IF(J.GE.2) GO TO 112
  120 CONTINUE
      DO 140 I = 1,NG
        DO 139 J = 1,M(I)+1
          IF(J.EQ.1) THEN
            C(J,I) = X(J,I)/(N+1)
          ELSEIF(J.EQ.M(I)+1) THEN
            C(J,I) = ONE-X(J-1,I)/(N+1)
          ELSE
            C(J,I) = (X(J,I)-X(J-1,I))/(N+1)
          ENDIF
  139   CONTINUE
  140 CONTINUE
      T = ZERO
      DO 190 I = 1,NG
        DO 189 J = 1,M(I)+1
          T = T+DABS(C(J,I)-ONE/(M(I)+1))**V
  189   CONTINUE
  190 CONTINUE
      IF(T.GT.T1) KOUNT2 = KOUNT2+1
      RETURN
      END
