      PROGRAM GF
      IMPLICIT REAL*8(A-H,O-Z)
C
C        PROGRAM MODIFIED 8/14/2003
C
C  IF K > 250, REPLACE 250 WITH K IN P(K) AND M(K) THE ABOVE STATEMENTS.
C
      CHARACTER  FOUT*40
      DIMENSION  M(250),P(250)
C
      WRITE(*,*) 'ENTER K,M(1),...,M(K)'
      READ(*,*) K,(M(I),I=1,K)
      WRITE(*,*) 'ENTER (0,1) FOR (EQUAL,UNEQUAL) CELL PROBABILITIES:'
      READ(*,*) L
      IF(L.EQ.1) THEN
        WRITE(*,*) 'ENTER P(1),...,P(K-1)'
        READ(*,*) (P(I),I=1,K-1)
      ELSE
        P(1) = 1.0D0/DBLE(K)
        DO 1 I = 2,K-1
          P(I) = P(1)
    1   CONTINUE
      ENDIF
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,2) FOUT
    2 FORMAT(A)
      ZERO = 0.0D0
      ONE = 1.0D0
      N = 0
      DO 3 I = 1,K
        N = N+M(I)
    3 CONTINUE
      DN = ONE*N
      W = ZERO
      DO 6 I = 1,K-1
        IF(P(I).LE.ZERO)  STOP 'A P(I) IS NONPOSITIVE'
        W = W+P(I)
    6 CONTINUE
      IF(W.GE.ONE)  STOP 'P(K) IS NONPOSITIVE OR FAULTY P(I) VALUES'
      P(K) = ONE-W
      T = ZERO
      S = ZERO
      TLR = ZERO
      E1 = ZERO
      E2 = ZERO
      F = ZERO
      DO 10 I=1,K
        T = T+(P(I)*DN-M(I))**2/(P(I)*DN)
        S = S+ONE*M(I)*(M(I)-1)/(P(I)*DN)
        TLR = TLR+RZ(M(I))-DLOG(P(I)*N)*M(I)
        E1 = E1+ONE/(P(I)*DN)
        E2 = E2+ONE/(P(I)*DN)**2
        F = F+ONE/P(I)
   10 CONTINUE
      TLR = TLR*2
      C1 = ONE*(K-1)
      C2 = ONE*(K-1)*2+(ONE*3-(K+1)**2)/DN+E1
      C3 = ONE*(K-1)*8-ONE*(K*6-4)*(K*3+8)/DN+E1*(22-(K*3+22)/DN)
     +     +ONE*(K*2+6)*(K*K+K*6-4)/DN**2+E2
      D1 = DN-1
      D2 = (DN-1)*(K-1)*2/DN
      D3 = (DN*(K-1)*2-K*7+6+F)*(DN-1)*4/DN**2
      ZT = (T-C1)/DSQRT(C2)
      ZS = (S-D1)/DSQRT(D2)
      GAMT = C3/(DSQRT(C2))**3
      GAMS = D3/(DSQRT(D2))**3
C
      OPEN(5,FILE=FOUT,STATUS='NEW')
      WRITE(5,15) 'DISCRETE GOODNESS-OF-FIT ANALYSES WITH ',
     +             K,' CELLS AND ',N,' TOTAL CASES'
      WRITE(5,20) T, ' = PEARSON GOODNESS-OF-FIT STATISTIC T'
      WRITE(5,20) C1, ' = E[T]'
      WRITE(5,20) C2, ' = VAR(T)'
      WRITE(5,20) GAMT, ' = SKEWNESS OF T'
      WRITE(5,20) ZT, ' = (T-E[T])/SQRT(VAR(T))'
      CALL PVALUE(ZT,GAMT,PROBT)
      WRITE(5,20) PROBT, ' = NONASYMPTOTIC P-VALUE OF T'
      WRITE(5,30) K-1, ' = DEGREES OF FREEDOM FOR ASYMPTOTIC TESTS'
      IF(T.GT.ZERO) THEN
         CALL CHISQ(T,K-1,APCS)
      ELSE
         APCS = ONE
      ENDIF
      WRITE(5,25) APCS, ' = ASYMPTOTIC P-VALUE OF T'
      WRITE(5,20) S, ' = ZELTERMAN GOODNESS-OF-FIT STATISTIC S'
      WRITE(5,20) D1, ' = E[S]'
      WRITE(5,20) D2, ' = VAR(S)'
      WRITE(5,20) GAMS, ' = SKEWNESS OF S'
      WRITE(5,20) ZS, ' = (S-E[S])/SQRT(VAR(S))'
      CALL PVALUE(ZS,GAMS,PROBS)
      WRITE(5,20) PROBS, ' = NONASYMPTOTIC P-VALUE OF S'
      IF(S.GT.DN-K) THEN
         CALL CHISQ(S+K-N,K-1,APZ)
      ELSE
         APZ = ONE
      ENDIF
      WRITE(5,25) APZ, ' = ASYMPTOTIC P-VALUE OF S'
      WRITE(5,20) TLR, ' = LIKELIHOOD-RATIO G-O-F TEST STATISTIC'
      IF(TLR.GT.ZERO) THEN
         CALL CHISQ(TLR,K-1,APLR)
      ELSE
         APLR = ONE
      ENDIF
      WRITE(5,20) APLR, ' = ASYMPTOTIC LIKELIHOOD-RATIO TEST P-VALUE'
   15 FORMAT(/,T2,A,I3,A,I9,A,/)
   20 FORMAT(T5,G15.8,A)
   25 FORMAT(T5,G15.8,A,/)
   30 FORMAT(T5,I4,A)
      END
C
C
      SUBROUTINE PVALUE(Z,GAM,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE OF
C        Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE OF Z.
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      F = R*R+10
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)-
     +    ONE/(F*F*F*360)
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      A  = R*R-1
      B  = R*R*(DLOG(R)-1)-U
      W  = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(Z.LT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = Z
      Y = Z+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(I*2-1))-R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H4 = E(G)
      PROB = G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   30 IF(Z.GT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = Z-15
      Y = Z
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(I*2-1))+R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H4 = E(G)
      PROB = ONE-G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-738.0D0) GO TO 70
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 60
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-738.0D0) E = DEXP(G)
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION RZ(I)
C
C  FIND I(LOG(I))
C
      DOUBLE PRECISION  X
      X = 1.0D0*I
      IF(X.GT.1.5D0) THEN
         RZ = X*DLOG(X)
      ELSE
         RZ = 0.0D0
      ENDIF
      RETURN
      END
C...........................................................................
      SUBROUTINE CHISQ(T,N,P)
      DOUBLE PRECISION T,ZERO,ONE,V,X,P,PI,PX,A,B,E1,E2,E3,E4,E5,H,W
      ZERO = 0.0D0
      ONE = 1.0D0
      IF(T.LE.ZERO) THEN
         P = ONE
         GO TO 60
      END IF
      IF(N.EQ.1) THEN
         X = DSQRT(T)
         CALL PVN(X,PX)
         P = PX*2
         GO TO 60
      END IF
      V = ONE*N
      IF(V/2-N/2.GT.0.1D0) GO TO 30
      P = DEXP(-T/2)
      IF(N.LT.3) GO TO 60
      K = (N-2)/2
      B = ONE
      DO 20 J = 1,K
         L = J
         A = ONE
         DO 10 I = 1,L
            A = A*T/(2*I)
   10    CONTINUE
         B = B+A
   20 CONTINUE
      P = P*B
      GO TO 60
   30 PI = DATAN(ONE)*4
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*DSQRT(T)+1)
      P = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*DEXP(-T/2)/DSQRT(PI/2)
      IF(N.LT.2) GO TO 60
      K = (N-1)/2
      B = ZERO
      DO 50 J = 1,K
         L = J
         A = ONE
         DO 40 I = 1,L
            A = A*T/(2*I-1)
   40    CONTINUE
         B = B+A
   50 CONTINUE
      P = P+B*DEXP(-T/2)/DSQRT(PI*T/2)
   60 RETURN
      END
C
C
      SUBROUTINE PVN(Z,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE OF
C        Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE OF Z.
C
      DOUBLE PRECISION  Z,PROB,ZERO,ONE,PI,G,A,B,C,EE,H,
     +   U,W,E1,E2,E3,E4,E5
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 20
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 10
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*EE(G)/DSQRT(PI*2)
      GO TO 20
   10 B = 2.2D0
      C = 4.9D0
      PROB = EE(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   20 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION EE(G)
C
      DOUBLE PRECISION G
C
      EE = 0.0D0
      IF(G.GE.-709.1D0) EE = DEXP(G)
      RETURN
      END
