      program ptn
c
c     This program computes the number of Euler partitions, e(n), and the
c     the number of distinct partitions for n given n ordered positions,
c     f(n) = (2n-1)!/[n!(n-1)!, and the ratio f(n)/e(n).  The output values
c     given on each line of the output follow:  n, e(n), f(n), f(n)/e(n)
c
      double precision p(0:400), sign, c(400), r(400), comb
      integer          i, j, k
c
   10 write  (*,20) 'The number of Euler partitions for n = '
   20 format (t2,a,$)
      read   (*,*) n
      if (n.gt.300) then
         write  (*,30) 'Number of partitions cannot exceed 300'
   30    format (/,t2,a,/)
         go to 10
      end if
c
      p(0) = 1.0d0
      do 70 i = 1, n
         sign = 1.0d0
         p(i) = 0.0d0
         do 40 j = 1, 100
            k = j*(3*j-1)/2
            if (i-k.lt.0) go to 50
            p(i) = p(i)+sign*p(i-k)
            c(i) = comb(2*i-1,i)
            r(i) = c(i)/p(i)
            k = j*(3*j+1)/2
            if (i-k.lt.0) go to 50
            p(i) = p(i)+sign*p(i-k)
            c(i) = comb(2*i-1,i)
            r(i) = c(i)/p(i)
            sign = -1.0d0*sign
   40    continue
   50    write (*,60) i, p(i), c(i), r(i)
   60    format (t2,i3,e20.13,e20.13,e20.13)
   70 continue
      end
C
C
      DOUBLE PRECISION FUNCTION COMB(N,M)
      DOUBLE PRECISION  ONE,PI,R,Z,D,F,U1,U2,U3
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      R = DLOG(PI*2)/2
      Z = ONE+N
      D = Z
      F = Z+10
      DO 10 I = 1,9
         D = D*(Z+I)
   10 CONTINUE
      U1 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+M
      D = Z
      F = Z+10
      DO 20 I = 1,9
         D = D*(Z+I)
   20 CONTINUE
      U2 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+N-M
      D = Z
      F = Z+10
      DO 30 I = 1,9
         D = D*(Z+I)
   30 CONTINUE
      U3 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1180)
      COMB = DEXP(U1-U2-U3)
      RETURN
      END
