      PROGRAM RMEDQ
      INTEGER R
      DOUBLE PRECISION X(700,10),W1(10),W2(10),ZERO,ONE,V(10),Z(10),
     +  Y(700),U(700),D,G,P,S,T,W
      CHARACTER FIN*40,FOUT*40,DIS*40
C
C           R-DIMENSIONAL MEDIAN PROGRAM REQUIREMENT:   R  2
C           (ADJUST DIMENSION STATEMENT IF R  11 OR N  701)
C
    1 FORMAT(A)
      WRITE(*,*) 'ENTER N (# OF OBJECTS), R (DIMENSIONS), T (TOLERANCE)'
      READ(*,*) N,R,T
      WRITE(*,*) 'ENTER P FOR SELECTED P-TH QUANTILE (0 < P < 1)'
      READ(*,*) P
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,1) FIN
      WRITE(*,*) 'ENTER FILE NAME OF OUTPUT RESULTS'
      READ(*,1) FOUT
      WRITE(*,*) 'ENTER FILE NAME FOR DISTANCES FROM MEDIAN'
      READ(*,1) DIS
      OPEN(1,FILE = FIN)
      READ(1,*) ((X(I,J),J=1,R),I=1,N)
      CLOSE(1)
      ZERO = 0.0D0
      ONE = 1.0D0
      DO 20 J = 1,R
        W1(J) = ZERO
        DO 10 I = 1,N
          W1(J) = W1(J)+X(I,J)
   10   CONTINUE
        W1(J) = W1(J)/N
   20 CONTINUE
      M = 0
   25 M = M+1
      IF(M.GT.500) GO TO 75
      DO 50 J = 1,R
        V(J) = ZERO
        Z(J) = ZERO
        DO 40 I = 1,N
          Y(I) = ZERO
          DO 30 K = 1,R
            Y(I) = Y(I)+(X(I,K)-W1(K))**2
   30     CONTINUE
          V(J) = V(J)+X(I,J)/DSQRT(Y(I))
          Z(J) = Z(J)+ONE/DSQRT(Y(I))
   40   CONTINUE
        W2(J) = V(J)/Z(J)
   50 CONTINUE
      S = ZERO
      DO 60 J = 1,R
        S = S+DABS(W1(J)-W2(J))
   60 CONTINUE
      IF(S.LT.T) GO TO 75
      DO 70 J = 1,R
        W1(J) = W2(J)
   70 CONTINUE
      GO TO 25
   75 D = ZERO
      DO 78 I = 1,N
        Y(I) = ZERO
        DO 77 J = 1,R
          Y(I) = Y(I)+(X(I,J)-W2(J))**2
   77   CONTINUE
        Y(I) = DSQRT(Y(I))
        U(I) = Y(I)
        D = D+Y(I)
   78 CONTINUE
      D = D/N
C
C           Y(I) IS THE DISTANCE FROM THE ITH POINT TO THE MEDIAN
C
      OPEN(2,FILE = FOUT,STATUS = 'NEW')
      WRITE(2,80) R,'-DIMENSIONAL MEDIAN & DISTANCE QUANTILES'
   80 FORMAT(T10,I2,A,//)
      WRITE(2,82) 'NUMBER OF OBSERVATIONS = ',N
      WRITE(2,82) 'NUMBER OF ITERATIONS = ',M
   82 FORMAT(T5,A,I3)
      WRITE(2,83) 'TOLERANCE = ',T
   83 FORMAT(/,T5,A,E7.1,/)
      DO 85 J = 1,R
        WRITE(2,87) 'VALUE OF COORDINATE NUMBER ',J,' = ',W2(J)
   85 CONTINUE
   87 FORMAT(T5,A,I2,A,G16.10)
      WRITE(2,88) 'AVERAGE DISTANCE TO MEDIAN = ',D
   88 FORMAT(/,T5,A,G16.10,/)
C
      OPEN(5,FILE=DIS,STATUS='NEW')
      DO 89 I = 1,N
        WRITE(5,*) Y(I)
   89 CONTINUE
      CLOSE(5)
C
      J = N
      K = J/2+1
   91 K = K-1
      W = U(K)
      GO TO 93
   92 W = U(J)
      U(J) = U(1)
      J = J-1
   93 II = K
   94 L = 2*II
      IF(L-J)  95,96,97
   95 IF(U(L+1).GE.U(L)) L = L+1
   96 IF(W.GE.U(L)) GO TO 97
      U(II) = U(L)
      II = L
      GO TO 94
   97 U(II) = W
      IF(K.GT.1) GO TO 91
      IF(J.GE.2) GO TO 92
      WRITE(2,88) 'SELECTED VALUE OF P FOR P-TH QUANTILE =', P
      K = MAX(1,IDNINT(P*N+0.5D0))
      WRITE(2,99) 'P-TH QUANTILE =',U(K)
   99 FORMAT(T5,A,G16.10)
      WRITE(2,99) '0.0-TH QUANTILE (MINIMUM VALUE) =',U(1)
      K = MAX(1,IDNINT(0.05D0*N+0.5D0))
      WRITE(2,99) 'O.O5-TH QUANTILE =',U(K)
      K = MAX(1,IDNINT(0.1D0*N+0.5D0))
      WRITE(2,99) '0.1-TH QUANTILE =',U(K)
      K = MAX(1,IDNINT(0.25D0*N+0.5D0))
      WRITE(2,99) '0.25-TH QUANTILE =',U(K)
      K = IDINT(0.5D0*N+0.51D0)
      G = U(K)
      L = N/2
      IF(K.EQ.L) G = (U(K)+U(K+1))/2
      WRITE(2,99) '0.5-TH QUANTILE (MEDIAN VALUE) =',G
      K = MIN(N,IDNINT(0.75D0*N+0.5D0))
      WRITE(2,99) '0.75-TH QUANTILE =',U(K)
      K = MIN(N,IDNINT(0.9D0*N+0.5D0))
      WRITE(2,99) '0.9-TH QUANTILE =',U(K)
      K = MIN(N,IDNINT(0.95D0*N+0.5D0))
      WRITE(2,99) '0.95-TH QUANTILE =',U(K)
      WRITE(2,99) '1.0-TH QUANTILE (MAXIMUM VALUE) =',U(N)
      CLOSE(2)
      END
