      PROGRAM YSRXC
      IMPLICIT REAL*8(A-H,O-Z)
C
C        PROGRAM MODIFIED 4/29/2006
C
C  MODIFIED PROGRAM SRXC TO INCLUDE GOODMAN-KRUSKAL TAU-A AND TAU-B ANALYSES.
C
      CHARACTER  FOUT*40
      DIMENSION  U(17),IR(20),IC(30),ICA(30),L(20,30),M(20,30)
C
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,*) 'ENTER NUMBER OF ROWS AND NUMBER OF COLUMNS:'
      READ(*,*) NROW,NCOL
      DO 2 I = 1,NROW
         WRITE(*,*) 'ENTER ROW',I
         READ(*,*) (L(I,J),J = 1,NCOL)
    2 CONTINUE
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 4 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 3 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
    3    CONTINUE
         U(II) = S
    4 CONTINUE
      IT = 0
      SR = 0.0D0
      SC = 0.0D0
      PSTART = 0.0D0
      DO 6 I = 1,NROW
         IR(I) = 0
         DO 5 J = 1,NCOL
            IR(I) = IR(I)+L(I,J)
    5    CONTINUE
         IT = IT+IR(I)
         SR = SR+(1.0D0*IR(I))**2
         PSTART = PSTART+FAC(IR(I))
    6 CONTINUE
      DO 8 J = 1,NCOL
         IC(J) = 0
         DO 7 I = 1,NROW
            IC(J) = IC(J)+L(I,J)
    7    CONTINUE
         SC = SC+(1.0D0*IC(J))**2
         PSTART = PSTART+FAC(IC(J))
    8 CONTINUE
      PSTART = PSTART-FAC(IT)
      CR = RZ(IT)
      DO 9 I = 1,NROW
         CR = CR-RZ(IR(I))
    9 CONTINUE
      DO 10 J = 1,NCOL
         CR = CR-RZ(IC(J))
   10 CONTINUE
C  DETERMINE THE PROBABILITY OF THE OBSERVED TABLE.
      CELLFAC = 0.0D0
      DO 12 I = 1,NROW
         DO 11 J = 1,NCOL
            CELLFAC = CELLFAC+FAC(L(I,J))
   11    CONTINUE
   12 CONTINUE
      THISP = (PSTART-CELLFAC)*(1.0D0-1.0D-12)
      FEP = DEXP(THISP)
      CS = 0.0D0
      DO 15 I = 1,NROW
         DO 14 J = 1,NCOL
            CS = CS+(1.0D0*L(I,J))**2/IR(I)/IC(J)
   14    CONTINUE
   15 CONTINUE
      CST = (CS-1.0D0)*IT*(1.0D0-1.0D-12)
      IF(CST.LT.1.0D-11) CST = -1.0D-11
      CA = 0.0D0
      DO 18 I = 1,NROW
         DO 17 J = 1,NCOL
            CA = CA+(1.0D0*L(I,J))**2/IC(J)
   17    CONTINUE
   18 CONTINUE
      CTA = (CA*IT-SR)*(1.0D0-1.0D-12)/(1.0D0*IT*IT-SR)
      IF(CTA.LT.1.0D-11) CAT = -1.0D-11
      CB = 0.0D0
      DO 21 I = 1,NROW
         DO 20 J = 1,NCOL
            CB = CB+(1.0D0*L(I,J))**2/IR(I)
   20    CONTINUE
   21 CONTINUE
      CTB = (CB*IT-SC)*(1.0D0-1.0D-12)/(1.0D0*IT*IT-SC)
      IF(CTB.LT.1.0D-11) CBT = -1.0D-11
      CZ = 0.0D0
      DO 24 I = 1,NROW
         DO 23 J = 1,NCOL
            CZ = CZ+1.0D0*L(I,J)*(L(I,J)-1)/IR(I)/IC(J)
   23    CONTINUE
   24 CONTINUE
      CZT = CZ*(1.0D0-1.0D-12)
      IF(CZT.LT.1.0D-11) CZT = -1.0D-11
      CL = 0.0D0
      DO 28 I = 1,NROW
         DO 27 J = 1,NCOL
            CL = CL+RZ(L(I,J))
   27    CONTINUE
   28 CONTINUE
      CLT = (CL+CR)*2*(1.0D0-1.0D-12)
      IF(DABS(CLT).LT.1.0D-12) CLT = -1.0D-12
      IFE = 0
      ICS = 0
      IKA = 0
      IKB = 0
      ICZ = 0
      ICL = 0
C
      DO 30 IS = 1,MS
         CALL RCONT2(IT,NROW,NCOL,SR,SC,CF,CS,CA,CB,CZ,CL,CR,
     +               U,IR,IC,ICA,M)
         CP = PSTART-CF
         IF(CP.LT.THISP) IFE = IFE+1
         IF(CS.GT.CST) ICS = ICS+1
         IF(CA.GT.CTA) IKA = IKA+1
         IF(CB.GT.CTB) IKB = IKB+1
         IF(CZ.GT.CZT) ICZ = ICZ+1
         IF(CL.GT.CLT) ICL = ICL+1
   30 CONTINUE
C
      PFE = 1.0D0*IFE/MS
      PCS = 1.0D0*ICS/MS
      PTA = 1.0D0*IKA/MS
      PTB = 1.0D0*IKB/MS
      PCZ = 1.0D0*ICZ/MS
      PCL = 1.0D0*ICL/MS
      OPEN(6,FILE=FOUT,STATUS='NEW')
C
      WRITE(6,40) 'TWO-WAY CONTINGENCY TABLE ANALYSES WITH ',
     +          NROW,' ROWS AND ',NCOL,' COLUMNS'
      WRITE(6,45) ISEED, ' = RANDOM NUMBER GENERATOR SEED'
      WRITE(6,45) MS, ' = NUMBER OF RANDOM TABLES GENERATED'
      WRITE(6,50) FEP, ' = PROBABILITY OF OBSERVED R BY C TABLE'
      WRITE(6,50) PFE, ' = SIMULATED FISHER''S EXACT TEST P-VALUE'
      IF(CST.LE.0.0D0) CST = 0.0D0
      WRITE(6,50) CST, ' = OBSERVED R BY C CHI-SQUARE STATISTIC T'
      WRITE(6,50) PCS, ' = SIMULATED CHI-SQUARE TEST P-VALUE'
      IF(CTA.LE.0.0D0) CTA = 0.0D0
      WRITE(6,50) CTA, ' = OBSERVED R BY C TAU-A STATISTIC'
      WRITE(6,50) PTA, ' = SIMULATED TAU-A TEST P-VALUE'
      IF(CTB.LE.0.0D0) CTB = 0.0D0
      WRITE(6,50) CTB, ' = OBSERVED R BY C TAU-B STATISTIC'
      WRITE(6,50) PTB, ' = SIMULATED TAU-B TEST P-VALUE'
      IF(CZT.LE.0.0D0) CZT = 0.0D0
      WRITE(6,50) CZT, ' = OBSERVED R BY C ZELTERMAN STATISTIC'
      WRITE(6,50) PCZ, ' = SIMULATED ZELTERMAN TEST P-VALUE'
      IF(CLT.LE.0.0D0) CLT = 0.0D0
      WRITE(6,50) CLT, ' = OBSERVED R BY C LIKELIHOOD-RATIO STATISTIC'
      WRITE(6,50) PCL, ' = SIMULATED LIKELIHOOD-RATIO TEST P-VALUE'
   40 FORMAT(T2,A,I3,A,I3,A,/)
   45 FORMAT(T5,I10,A)
   50 FORMAT(T5,G15.8,A)
      END
C
C
      SUBROUTINE RCONT2(NTOTAL,NROW,NCOL,SR,SC,CF,CS,CA,CB,CZ,CL,CR,
     +                  U,NROWT,NCOLT,JWORK,MATRIX)
      IMPLICIT REAL*8(A-H,O-Z)
C
C       ALGORITHM AS 159 APPL. STATIST. (1981) VOL.30, NO.1
C    GENERATES RANDOM TWO-WAY TABLE WITH GIVEN MARGINAL TOTALS
C    RESTRICTIONS: NTOTAL < 5001, 1 < NROW < 21, 1 < NCOL < 31
C
      DIMENSION  U(17),NROWT(NROW),NCOLT(NCOL),JWORK(NCOL),
     +           MATRIX(NROW,NCOL)
      LOGICAL  LSP,LSM
C
      NROWM = NROW-1
      NCOLM = NCOL-1
      DO 105 J = 1,NCOLM
        JWORK(J) = NCOLT(J)
  105 CONTINUE
      JC = NTOTAL
      DO 190 L = 1,NROWM
        NROWTL = NROWT(L)
        IA = NROWTL
        IC = JC
        JC = JC-NROWTL
        DO 180 M = 1,NCOLM
          ID = JWORK(M)
          IE = IC
          IC = IC-ID
          IB = IE-IA
          II = IB-ID
C
C            TEST FOR ZERO ENTRIES IN MATRIX
C
          IF(IE.NE.0) GO TO 130
          DO 121 J = M,NCOL
            MATRIX(L,J) = 0
  121     CONTINUE
          GO TO 190
C
C           GENERATE PSEUDO-RANDOM NUMBER
C
  130     RAND = UNI(U)
C
C           COMPUTE CONDITIONAL EXPECTED VALUE OF MATRIX(L,M)
C
  131     NLM = IDINT(0.5D0+1.0D0*IA*ID/IE)
          IG = ID-NLM
          IH = IA-NLM
          IIQ = II+NLM
          X = DEXP(FAC(IA)+FAC(IB)+FAC(IC)+FAC(ID)-FAC(IE)
     +             -FAC(NLM)-FAC(IG)-FAC(IH)-FAC(IIQ))
          IF(X.GE.RAND) GO TO 160
          SUMPRB = X
          Y = X
          NLL = NLM
          LSP = .FALSE.
          LSM = .FALSE.
C
C           INCREMENT ENTRY OF ROW L AND COLUMN M
C
  140     J = (ID-NLM)*(IA-NLM)
          IF(J.EQ.0) GO TO 156
          NLM = NLM+1
          X = X*J/(NLM*(II+NLM))
          SUMPRB = SUMPRB+X
          IF(SUMPRB.GE.RAND) GO TO 160
  150     IF(LSM) GO TO 155
C
C           DECREMENT ENTRY OF ROW L AND COLUMN M
C
          J = NLL*(II+NLL)
          IF(J.EQ.0) GO TO 154
          NLL = NLL-1
          Y = Y*J/((ID-NLL)*(IA-NLL))
          SUMPRB = SUMPRB+Y
          IF(SUMPRB.GE.RAND) GO TO 159
          IF(.NOT.LSP) GO TO 140
          GO TO 150
  154     LSM = .TRUE.
  155     IF(.NOT.LSP) GO TO 140
          RAND = SUMPRB*UNI(U)
          GO TO 131
  156     LSP = .TRUE.
          GO TO 150
  159     NLM = NLL
  160     MATRIX(L,M) = NLM
          IA = IA-NLM
          JWORK(M) = JWORK(M)-NLM
  180   CONTINUE
        MATRIX(L,NCOL) = IA
  190 CONTINUE
C
C           COMPUTE ENTRIES IN LAST ROW OF MATRIX
C
      DO 192 M = 1,NCOLM
        MATRIX(NROW,M) = JWORK(M)
  192 CONTINUE
      MATRIX(NROW,NCOL) = IB-MATRIX(NROW,NCOLM)
      CF = 0.0D0
      DO 220 I = 1,NROW
        DO 219 J = 1,NCOL
          CF = CF+FAC(MATRIX(I,J))
  219   CONTINUE
  220 CONTINUE
      CS = 0.0D0
      DO 225 I = 1,NROW
        DO 224 J = 1,NCOL
          CS = CS+(1.0D0*MATRIX(I,J))**2/NROWT(I)/NCOLT(J)
  224   CONTINUE
  225 CONTINUE
      CS = (CS-1.0D0)*NTOTAL
      CA = 0.0D0
      DO 230 I = 1,NROW
        DO 229 J = 1,NCOL
          CA = CA+(1.0D0*MATRIX(I,J))**2/NCOLT(J)
  229   CONTINUE
  230 CONTINUE
      CA = (CA*NTOTAL-SR)/(1.0D0*NTOTAL**2-SR)
      CB = 0.0D0
      DO 235 I = 1,NROW
        DO 234 J = 1,NCOL
          CB = CB+(1.0D0*MATRIX(I,J))**2/NROWT(I)
  234   CONTINUE
  235 CONTINUE
      CB = (CB*NTOTAL-SC)/(1.0D0*NTOTAL**2-SC)
      CZ = 0.0D0
      DO 240 I = 1,NROW
        DO 239 J = 1,NCOL
          CZ = CZ+1.0D0*MATRIX(I,J)*(MATRIX(I,J)-1)/NROWT(I)/NCOLT(J)
  239   CONTINUE
  240 CONTINUE
      CL = 0.0D0
      DO 245 I = 1,NROW
        DO 244 J = 1,NCOL
          CL = CL+RZ(MATRIX(I,J))
  244   CONTINUE
  245 CONTINUE
      CL = (CL+CR)*2
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(5000)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION RZ(I)
C  FIND I(LOG(I))
      DOUBLE PRECISION X
      X = 1.0D0*I
      IF(X.GT.1.5D0) THEN
         RZ = X*DLOG(X)
      ELSE
         RZ = 0.0D0
      ENDIF
      RETURN
      END
